import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.List;

/*
 * Created on May 24, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author fred
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PlaylistForm extends List implements CommandListener {

	Controller controller;
	Command doneCommand;
	Command playCommand;
	Command clearCommand;
	String[] lastItems;
	int lastItemPos;
	
	public PlaylistForm(Controller controller) {
		super("Playlist", List.IMPLICIT);
		lastItemPos = 0;
		lastItems = null;
		this.controller = controller;
		
		setCommandListener(this);
		
		playCommand = new Command("Play", "Play track", Command.ITEM, 2);
		setSelectCommand(playCommand);
		
		doneCommand = new Command("Back", Command.BACK, 1);
		addCommand(doneCommand);
		
		clearCommand = new Command("Clear", "Clear playlist", Command.SCREEN, 3);
		addCommand(clearCommand);
		
	}

	void updatePlaylist(int pos, String[] items) {
		if (items != lastItems || pos != lastItemPos) {
			
			for (int n=0; n<items.length; ++n) {
				String name = items[n];
				if (n == pos) {
					name = ">> "+name;
				}
				if (n < size()) {
					set(n, name, null);
				}
				else {
					insert(n, name, null);
				}
				setFont(n, Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL));
				
			}
			while (items.length < size()) {
				for (int i = items.length; i < size(); i++) {
					delete(i);
				}
			}
			
			lastItems = items;
			lastItemPos = pos;
		}
	}
	
	public void commandAction(Command cmd, Displayable display) {
		if (cmd == playCommand) {
			controller.protocol.setCurrentTrack(getSelectedIndex());
			//controller.protocol.refreshPlaylist();
		}
		else if (cmd == doneCommand) {
			controller.showController();
		}
		else if (cmd == clearCommand) {
			controller.protocol.clearPlaylist();
		}
	}

}
